【力扣】第397场周赛 A~C

原题链接:竞赛 - 力扣 (LeetCode)

目录

A.两个字符串的排列差

[B. 从魔法师身上吸取的最大能量](#B. 从魔法师身上吸取的最大能量)

[C. 矩阵中的最大得分](#C. 矩阵中的最大得分)


A.两个字符串的排列差

观察到字符串的长度最大只有26,所以直接O(n^2)暴力枚举累加绝对值之和即可。

cpp 复制代码
class Solution {
public:
    int findPermutationDifference(string s, string t) {
        int ans=0;
        for(int i=0;i<s.size();i++){
            for(int j=0;j<t.size();j++){
                if(s[i]==t[j]) {
                    ans+=abs(i-j);
                    break;
                }
            }
        }
        return ans;
    }
};

B. 从魔法师身上吸取的最大能量

解法一:后缀和

计算后缀和,枚举终点位置(不难分析出终点位置为 n-k到n-1),然后往前依次跳k个单位直到不能跳为止,每跳一次累加求和,并更新最大值。

用两重循环实现,复杂度为外层循环O(k)*内层循环O(n/k)=O(n),也可以理解数组每个数只会被跳一次,所以复杂度为O(n)。

解法二: dp。

开一个长度与原数组a 相同的dp数组,倒着遍历dp ,将dpi赋值为对应的ai,如果 i<n-k,将dpi+=dpi-k,每次将ans与dpi取最大值。

注意两种做法都需要将ans初始化成一个很小的值。

解法一代码:

cpp 复制代码
class Solution {
public:
    int maximumEnergy(vector<int>& a, int k) {
        int n=a.size(),ans=INT_MIN;
        for(int i=n-k;i<n;i++){
            int s=0;
            for(int j=i;j>=0;j-=k){
                s+=a[j];
                ans=max(ans,s);
            }
        }
        return ans;
    }
};

解法二代码:

cpp 复制代码
class Solution {
public:
    int maximumEnergy(vector<int>& a, int k) {
        int n=a.size(),ans=INT_MIN;
        vector<int> dp(n);
        for(int i=n-1;i>=0;i--){
            dp[i]=a[i];
            if(i<n-k) dp[i]+=dp[i+k];
            ans=max(ans,dp[i]);
        }
        return ans;
    }
};

C. 矩阵中的最大得分

学的是灵神的思路,然后补的题。将gridij视作海拔高度,题目计算的是重力势能的变化量之和,也就是终点的海拔高度 - 起点的海拔高度。要让这个值越大,那么起点海拔高度越小越好。

枚举终点的海拔高度,起点只能在(i,j)的左上方向(可以是正左或者正上),然后用二维前缀和的思想,

定义dpi+1j+1 表示 左上角在(0,0),右下角在(i,j)的子矩阵的最小值。(这里的横纵坐标都+1是怕出现用二维前缀和的思想中(这里会用到下标-1) 会出现越界的情况)

dpi+1j+1=min(dpi+1j,dpij+1,gridij)

cpp 复制代码
class Solution {
public:
    int maxScore(vector<vector<int>>& grid) {
        int ans=INT_MIN;
        int n=grid.size(),m=grid[0].size();
        vector<vector<int>> dp(n+1,vector<int>(m+1,INT_MAX));
        for(int i=0;i<n;i++){
            for(int j=0;j<m;j++){
                int mi=min(dp[i+1][j],dp[i][j+1]);
                ans=max(ans,grid[i][j]-mi);
                dp[i+1][j+1]=min(mi,grid[i][j]);
            }
        }
        return ans;
    }
};
相关推荐
Omics Pro42 分钟前
Cell封面|衰老生物学开源AI工具包
数据库·人工智能·算法·机器学习·自然语言处理
UIU1143 小时前
递归算法与汉诺塔
c++·学习·算法·c#·递归
用户979984807188 小时前
200 行代码写一个能跑的 AI Agent:不依赖任何框架,只靠 tool-calling 原理
算法
threerocks8 小时前
【Muse实战】X 流量作战室搭建保姆级教程 - 拥有你自己的运营团队
算法
lvwangshu8 小时前
P12960 毒药 题解
动态规划·题解·贪心·技巧·性质题·思维好题
GreenTea8 小时前
深度拆解 ScienceBuddy:如何用“双层递归自进化”构建高可靠科研 Agent Harness
前端·后端·算法
花椒技术9 小时前
2.46 秒生成 5 秒视频:拆解 H3 Max 的模型、推理栈与硬件协同
算法·音视频开发·视频编码
vivo互联网技术9 小时前
ART:妆容迁移框架,重新定义高保真妆容迁移 | ECCV 2026
人工智能·算法·图像识别
用户0441440924499 小时前
卫星信号模拟器里的四个坐标转换公式
算法
橘和柠9 小时前
阿里 open-code-review (AI代码审查工具)实战:安装、四层规则链、自定义规则格式与实测避坑
算法·面试